<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateBlockedLearnedPatternsReq StructType
 * @subpackage Structs
 */
class UpdateBlockedLearnedPatternsReq extends APIRequest
{
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | pattern
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The pattern
     * Meta information extracted from the WSDL
     * - choice: uuid | pattern
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $pattern;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The newPattern
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newPattern;
    /**
     * The prefix
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $prefix;
    /**
     * The clusterId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $clusterId;
    /**
     * The patternType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $patternType;
    /**
     * Constructor method for UpdateBlockedLearnedPatternsReq
     * @uses UpdateBlockedLearnedPatternsReq::setUuid()
     * @uses UpdateBlockedLearnedPatternsReq::setPattern()
     * @uses UpdateBlockedLearnedPatternsReq::setDescription()
     * @uses UpdateBlockedLearnedPatternsReq::setNewPattern()
     * @uses UpdateBlockedLearnedPatternsReq::setPrefix()
     * @uses UpdateBlockedLearnedPatternsReq::setClusterId()
     * @uses UpdateBlockedLearnedPatternsReq::setPatternType()
     * @param string $uuid
     * @param string $pattern
     * @param string $description
     * @param string $newPattern
     * @param string $prefix
     * @param string $clusterId
     * @param string $patternType
     */
    public function __construct($uuid = null, $pattern = null, $description = null, $newPattern = null, $prefix = null, $clusterId = null, $patternType = null)
    {
        $this
            ->setUuid($uuid)
            ->setPattern($pattern)
            ->setDescription($description)
            ->setNewPattern($newPattern)
            ->setPrefix($prefix)
            ->setClusterId($clusterId)
            ->setPatternType($patternType);
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setUuid($uuid = null)
    {
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get pattern value
     * @return string|null
     */
    public function getPattern()
    {
        return isset($this->pattern) ? $this->pattern : null;
    }
    /**
     * Set pattern value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $pattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setPattern($pattern = null)
    {
        if (is_null($pattern) || (is_array($pattern) && empty($pattern))) {
            unset($this->pattern);
        } else {
            $this->pattern = $pattern;
        }
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get newPattern value
     * @return string|null
     */
    public function getNewPattern()
    {
        return $this->newPattern;
    }
    /**
     * Set newPattern value
     * @param string $newPattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setNewPattern($newPattern = null)
    {
        $this->newPattern = $newPattern;
        return $this;
    }
    /**
     * Get prefix value
     * @return string|null
     */
    public function getPrefix()
    {
        return $this->prefix;
    }
    /**
     * Set prefix value
     * @param string $prefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setPrefix($prefix = null)
    {
        $this->prefix = $prefix;
        return $this;
    }
    /**
     * Get clusterId value
     * @return string|null
     */
    public function getClusterId()
    {
        return $this->clusterId;
    }
    /**
     * Set clusterId value
     * @param string $clusterId
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setClusterId($clusterId = null)
    {
        $this->clusterId = $clusterId;
        return $this;
    }
    /**
     * Get patternType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPatternType()
    {
        return isset($this->patternType) ? $this->patternType : null;
    }
    /**
     * Set patternType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $patternType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateBlockedLearnedPatternsReq
     */
    public function setPatternType($patternType = null)
    {
        if (is_null($patternType) || (is_array($patternType) && empty($patternType))) {
            unset($this->patternType);
        } else {
            $this->patternType = $patternType;
        }
        return $this;
    }
}
